︠830e89ab-3eae-4165-9f71-d01fa605de76︠
%md

︡8f0cc183-1161-4cc4-99b8-45a395a0ff9b︡
︠7accd83a-3e79-4f28-844a-ce2d9175eb10︠
︡ad75c8fd-4618-4a6c-9704-7f8c74abe29a︡
︠1baa1106-ffb3-4696-bb39-24f196c9f212︠
︡78938814-3aa4-4df6-adf0-d161f2854a88︡
︠9d1523c6-2583-4553-928c-742f9eca099d︠
︡0bf4a5a8-171e-45db-b980-d5258674a4b9︡
︠4a24f34b-e34a-4e3a-a25b-cc44e9a670c0︠
︡88938a9c-8b64-4b35-96de-2cb25fd7c742︡
︠729e0f9e-8611-4c05-bef1-ec8b9ec45229︠
︠%auto

a = 5



︡0d4a87f8-0127-4275-ba5b-895ea7317ded︡{"auto":true}︡
︠36f74766-ab98-4b62-9e5c-49d2c2c1e5f0︠
a
︡9a5723b6-af48-4c36-891e-46ca0cae8cc0︡︡{"stdout":"5\n","done":false}︡{"done":true}
def psi_data(xmax):
    from math import log, pi
    v = [(0,0), (1,0), (1,log(2*pi))]
    y = v[-1][1]
    for pn in prime_powers(2,xmax+1):
        y += log(factor(pn)[0][0])
        v.append( (pn,y) )
    v.append((xmax,y))
    return v

def plot_psi(xmax, **kwds):
    v = psi_data(xmax)
    return plot_step_function(v, **kwds)

def fig_psi(dir,ext):
    for m in [9,38,100,200]:
        g = plot_psi(m, thickness=2)
        g.save(dir+'/psi_%s.%s'%(m,ext), aspect_ratio=1, gridlines=True,
               fontsize=16, figsize=4, typeset='latex')
    g = plot(lambda x:x,1,1000,rgbcolor='red', thickness=.7) + plot_psi(1000,alpha=0.8, thickness=.7)
    g.save(dir+'/psi_diag_%s.%s'%(1000,ext),aspect_ratio=1, gridlines=True, fontsize=12, figsize=4, typeset='latex')

def plot_Psi(xmax, **kwds):
    v = psi_data(xmax)
    v = [(log(a),b) for a, b in v if a]
    return plot_step_function(v, **kwds)

def fig_Psi():
    m = 38
    g = plot_Psi(m, thickness=2)
    g.show()
    return

def fig_Psiprime():
    g = line([(0,0),(0,100)], rgbcolor='black')
    xmax = 20
    for n in [1..xmax]:
        if is_prime_power(n):
            if n == 1:
                h = log(2*pi)
            else:
                h = log(factor(n)[0][0])
            h = float(h)*50
            g += arrow((log(n),-1),(log(n),h), width=2)
            g += line([(log(n),-2), (log(n),150)], rgbcolor='black')
            if n <= 3 or n in [5, 8, 13, 19]:
                g += text("log(%s)"%n, (log(n),-8), rgbcolor='black', fontsize=12)
                g += line([(log(n),-2), (log(n),0)], rgbcolor='black')
    g += line([(-1/2,0), (xmax+1,0)], thickness=2)
    g.show()
    return

def fig_Phi():
    g = line([(0,0),(0,100)], rgbcolor='black')
    xmax = 20
    ymax = 50
    for n in [1..xmax]:
        if is_prime_power(n):
            if n == 1:
                h = log(2*pi)
            else:
                h = log(factor(n)[0][0])
            h /= sqrt(n)
            h = float(h)*50
            g += arrow((log(n),0),(log(n),h), width=1)
            g += arrow((-log(n),0),(-log(n),h), width=1)
            g += line([(log(n),0),(log(n),100)], color='black', thickness=.3)
            g += line([(-log(n),0),(-log(n),100)], color='black', thickness=.3)
            if n in [2, 5, 16]:
                g += text("log(%s)"%n, (log(n),-5), rgbcolor='black', fontsize=12)
                g += line([(log(n),-2), (log(n),0)], rgbcolor='black')
                g += text("log(%s)"%n, (-log(n),-5), rgbcolor='black', fontsize=12)
                g += line([(-log(n),-2), (-log(n),0)], rgbcolor='black')
    g += line([(-log(xmax)-1,0), (log(xmax)+1,0)], thickness=2)

    g.show()

fig_Psi()
fig_Psiprime()
fig_Phi()
︡1e22047c-b0f4-4029-b4c0-24118710644b︡{"once":false,"file":{"show":true,"uuid":"fc76bce7-2576-44de-8a9c-431e98e42d89","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/1675/tmp_OjsKEX.svg"}}︡{"html":"<div align='center'></div>"}︡{"once":false,"file":{"show":true,"uuid":"00b377dd-05c4-45fb-bdfc-80355e821591","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/1675/tmp_Uex9ah.svg"}}︡{"html":"<div align='center'></div>"}︡{"once":false,"file":{"show":true,"uuid":"99317f89-73ff-4c3a-8200-ba49eb650d44","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/1675/tmp___23jY.svg"}}︡{"html":"<div align='center'></div>"}︡
︠963e91a3-43d4-42f2-b30b-de0a3b7173e3︠
def fig_riemann_spectrum_gaps():
    t = stats.TimeSeries(zeta_zeros())
    g = t.diffs().plot_histogram(bins=500, normalize=False)
    g.show()

fig_riemann_spectrum_gaps()
︡79e6ec28-c238-4b32-b80b-44ebe5146442︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"61487b88-1d81-47f7-a3f1-de95e20a1c0d","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/10418/tmp_GCfMLq.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠2ee7afaa-d46e-41c0-80fe-cbec869cd7d6︠
def fig_mini_phihat_even():
    G = plot_symbolic_phihat(5, 1, 100, 10000, zeros=True)
    G.show()


def fig_phihat_even():
    for bound in [5, 10, 20]:
        G = plot_symbolic_phihat(bound, 2, 100,
                            plot_points=10^5)
        G.show()

def fig_phihat_even_all():
    p = [plot_symbolic_phihat(n, 2,100) for n in [5,20,50,500]]
    [a.ymin(0) for a in p]
    for a in p:
        a.show()
    g = graphics_array([[a] for a in p],4,1)
    g.show()

def symbolic_phihat(bound):
    t = var('t')
    f = SR(0)#what is this - all expressions learned in calculus
    for pn in prime_powers(bound+1):
        if pn == 1: continue
        p, e = factor(pn)[0]
        f += - log(p)/sqrt(pn) * cos(t*log(pn))
    return f

#omit 2 and - signs for p = 3 (mod 4)
#do Fourier trans on sum in phi
def plot_symbolic_phihat(bound, xmin, xmax, plot_points=1000, zeros=True):
    f = symbolic_phihat(bound)
    P = plot(f, (t,xmin, xmax), plot_points=plot_points)
    if not zeros:
        return P
    ym = P.ymax()
    Z = []
    for y in zeta_zeros():
        if y > xmax: break
        Z.append(y)
    zeros = sum([arrow((x,ym),(x,0),rgbcolor='red',width=0.5,arrowsize=2)
                 for i, x in enumerate(Z)])
    return P + zeros
fig_mini_phihat_even()
#fig_phihat_even()
︡7fade89e-9499-405a-ae0a-376afeb68f0c︡︡{"done":false,"stderr":"Error in lines 1-4\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"sage/structure/sage_object.pyx\", line 1097, in sage.structure.sage_object.save (/projects/sage/sage-6.10/src/build/cythonized/sage/structure/sage_object.c:12013)\n    if not os.path.splitext(filename)[1] or not hasattr(obj, \"save\"):\n  File \"/projects/sage/sage-6.10/local/lib/python/posixpath.py\", line 98, in splitext\n    return genericpath._splitext(p, sep, altsep, extsep)\n  File \"/projects/sage/sage-6.10/local/lib/python/genericpath.py\", line 99, in _splitext\n    sepIndex = p.rfind(sep)\nAttributeError: 'NoneType' object has no attribute 'rfind'\n"}︡{"done":true}
︠519ea5de-91c8-4fbe-9028-bfd08745f9edas︠
@auto
def gauss_primepowers(bound):
    """
    Computes all powers of Gaussian primes less than a given norm.
    Returns them as a list
    """
    def pgen(I):
        I.is_principal()
        assert len(I._reduced_generators) == 1
        return I._reduced_generators[0]

    def exponentiate(base, power):
        res = base
        while power > 1:
            res = res * base
            power = power - 1
        return res

    K.<i> = QQ[sqrt(-1)]
    eles = K.primes_of_bounded_norm(bound-1)
    print "eles: ",
    print eles
    primes = [pgen(I) for I in eles]
    print "primes: ",
    print primes
    primepowers = []
    for p in primes:
        primepowers.append(p)
        n = 2
        p = exponentiate(p,n)
        while p.norm() < bound:
            primepowers.append(p)
            n = n + 1
            p = exponentiate(p,n)
    return primepowers

def zeros(y):
    s = os.popen('lcalc --zeros-interval -x 1 -y %s --stepsize .01 --twist-quadratic -s -4 -f -4'%y).readlines()
    return [float(z.split()[1]) for z in s]

#omit 2 and - signs for p = 3 (mod 4)
#do Fourier trans on sum in phi
def gauss_symbolic_phihat(bound):
    t = var('t')
    f = SR(0)#what is this - all expressions learned in calculus
    for pn in prime_powers(bound+1):
        if pn == 1: continue
        if pn % 2 != 0:
            p, e = factor(pn)[0]
            if p % 4 == 3:
                f += log(p)/sqrt(pn) * cos(t*log(pn))
            else:
                f += -log(p)/sqrt(pn) * cos(t*log(pn))
    return f

def gauss_plot_symbolic_phihat(bound, xmin, xmax, plot_points=1000, show_zeros=True):
    f = gauss_symbolic_phihat(bound)
    P = plot(f, (t,xmin, xmax), plot_points=plot_points)
    if not show_zeros:
        return P
    ym = P.ymax()
    Z = []
    for y in zeros(xmax):
        Z.append(y)
    zeros_arrows = sum([arrow((x,ym),(x,0),rgbcolor='red',width=0.5,arrowsize=2)
                 for i, x in enumerate(Z)])
    return P + zeros_arrows

def gauss_fig_mini_phihat_even():
    G = gauss_plot_symbolic_phihat(5, 1, 100, 10000)
    G.show()
︡b2fee4d2-e1cf-486c-9060-f127d7a079f4︡︡{"done":true}
︠c297a843-1d89-43c9-b2d5-16a2bc78370e︠
plot_symbolic_phihat(5, 2,100)
︡0ca247f1-360d-4c37-95ca-2afd23200339︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"6640e585-9e8d-48aa-bc2c-1b1e646397cc","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_7P8nUs.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠e714f59e-f44d-4558-91d5-afa91dd1d127︠
%time
frames = []
for n in [6,7,8]:
    print n
    p = gauss_plot_symbolic_phihat(n, 2,100)
    p.xmin(0); p.xmax(100); p.ymin(-2); p.ymax(2)
    frames.append(p)
︡6785f5e1-9690-4ca6-84eb-d820410bc44c︡︡{"stdout":"6\n7","done":false}︡{"stdout":"\n8","done":false}︡{"stdout":"\n","done":false}︡{"stdout":"CPU time: 12.98 s, Wall time: 13.63 s","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠bab4dcd8-689e-48fe-aee5-f7800e341dd8︠
animate(frames).save('a.gif', delay=50)
︡b460246f-596f-4ab0-8938-424959640f8a︡︡{"done":true}
︠2cf810fe-e2fb-499e-b00b-094054fbc8e9︠

for n in [5, 20, 50]:
    g = gauss_plot_symbolic_phihat(n, 2,100)
    g.show()
︡375b1f69-918c-4fc0-a281-aa3994429373︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"8870a952-dfb9-4cd2-92c6-ba53e65365dd","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_KqZnln.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"d8d4ccf5-287b-4477-92a7-5c1680d0623c","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_TeLgSC.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"34fb3426-1ec4-4a78-a1dd-bb4a24114d1f","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_QzCF7d.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠684e84c5-2e29-48c0-9ae4-717ed8492880︠
︡36eff9f1-3bf2-444e-ac69-969f936c0bd9︡
︠404dd021-03c0-4f2c-a711-dbc11a40e760︠
︡01eac369-853d-483d-9438-904ca4e8e90c︡
︠b6dfa719-a0f1-4c30-b9bd-c7f3423886a7︠
︠
︡2b966cd7-97bc-4741-8eaa-144a7f96bd41︡
︠ca374dea-c75b-46be-ba82-2cb9a483e2ccs︠
zeros(50)
︡ecaa635c-c7ab-4304-a34a-efc20744afa6︡︡{"stdout":"[6.0209489046976, 10.243770304167, 12.988098012312, 16.342607104587, 18.291993196124, 21.450611343983, 23.27837652046, 25.728756425089, 28.359634343025, 29.656384014593, 32.592186527117, 34.199957509213, 36.142880458303, 38.511923141719, 40.322674066691, 41.807084620005, 44.617891058662, 45.599584396792, 47.741562280939, 49.723129323783]\n","done":false}︡{"done":true}
︠5947195b-093d-440a-a5e2-4c18aa8d2262︠
def lbl(name, f):
    open("thesis/graphics/%s.tex"%name, 'w').write("$$f(t)=%s$$"%latex(f))
f = gauss_symbolic_phihat(3)
lbl("intro1", f)
p = f.plot(0,20)
save(p, 'thesis/graphics/intro1.pdf')
︡93f87849-4dd8-458f-aba1-4ac375059f0a︡︡{"done":true}
︠786ec046-81b5-4f4f-b91c-90d22e7cd695︠

︡6c717c82-b95b-4bc0-8ce1-881891a6a2b7︡︡{"done":true}
︠30d4b718-d6ce-4e9d-826e-33700b5fa234︠
f = gauss_symbolic_phihat(5); show(f)
lbl('intro2', f)
p = f.plot(0, 20)
p
save(p, 'thesis/graphics/intro2.pdf')

︡3fd8db8d-2ddb-4c40-b3ba-016832ec4cdb︡︡{"html":"<div align='center'>$\\displaystyle -\\frac{1}{5} \\, \\sqrt{5} \\cos\\left(t \\log\\left(5\\right)\\right) \\log\\left(5\\right) + \\frac{1}{3} \\, \\sqrt{3} \\cos\\left(t \\log\\left(3\\right)\\right) \\log\\left(3\\right)$</div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"77abaa91-f7f0-48b6-8e19-120219c74bdd","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/29813/tmp_H3Jbea.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠867f0251-a908-4908-a0df-54542131538a︠
f = gauss_symbolic_phihat(7)
lbl("intro3", f)
p = f.plot(0, 20)
save(p, 'thesis/graphics/intro3.pdf')
︡0c4edd56-4763-45ec-9392-fed138b5c2d5︡︡{"done":true}
︠d4818637-fff3-4a82-838a-47d450fd6d4c︠
f = gauss_symbolic_phihat(11); show(f)
f.plot(0, 20)
︡b9ca7377-9cd8-43b2-9ece-b0f2c7790dcf︡︡{"html":"<div align='center'>$\\displaystyle \\frac{1}{11} \\, \\sqrt{11} \\cos\\left(t \\log\\left(11\\right)\\right) \\log\\left(11\\right) + \\frac{1}{7} \\, \\sqrt{7} \\cos\\left(t \\log\\left(7\\right)\\right) \\log\\left(7\\right) - \\frac{1}{5} \\, \\sqrt{5} \\cos\\left(t \\log\\left(5\\right)\\right) \\log\\left(5\\right) + \\frac{1}{3} \\, \\sqrt{3} \\cos\\left(t \\log\\left(3\\right)\\right) \\log\\left(3\\right) + \\frac{1}{3} \\, \\cos\\left(t \\log\\left(9\\right)\\right) \\log\\left(3\\right)$</div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"a3b8847a-c37b-4791-96b5-9fb07ef87957","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_DOd1Aa.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠8f4aa5c5-bf5d-485b-85c2-84c1a51dab4a︠
f = gauss_symbolic_phihat(13); show(f)
f.plot(0, 20)

︡67f3b957-68a2-4c3c-81b9-8fabcbd28c99︡︡{"html":"<div align='center'>$\\displaystyle -\\frac{1}{13} \\, \\sqrt{13} \\cos\\left(t \\log\\left(13\\right)\\right) \\log\\left(13\\right) + \\frac{1}{11} \\, \\sqrt{11} \\cos\\left(t \\log\\left(11\\right)\\right) \\log\\left(11\\right) + \\frac{1}{7} \\, \\sqrt{7} \\cos\\left(t \\log\\left(7\\right)\\right) \\log\\left(7\\right) - \\frac{1}{5} \\, \\sqrt{5} \\cos\\left(t \\log\\left(5\\right)\\right) \\log\\left(5\\right) + \\frac{1}{3} \\, \\sqrt{3} \\cos\\left(t \\log\\left(3\\right)\\right) \\log\\left(3\\right) + \\frac{1}{3} \\, \\cos\\left(t \\log\\left(9\\right)\\right) \\log\\left(3\\right)$</div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"59be3c25-3c42-4550-a5bb-6251b7fec72e","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_R2DKqo.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠21413758-58c1-4f66-a5d3-65a9c8df67c2︠

f = gauss_symbolic_phihat(20); show(f)
f.plot(0, 20)
︡dbd33976-efd2-4a49-8f0c-fb51c67174a5︡︡{"html":"<div align='center'>$\\displaystyle \\frac{1}{19} \\, \\sqrt{19} \\cos\\left(t \\log\\left(19\\right)\\right) \\log\\left(19\\right) - \\frac{1}{17} \\, \\sqrt{17} \\cos\\left(t \\log\\left(17\\right)\\right) \\log\\left(17\\right) - \\frac{1}{13} \\, \\sqrt{13} \\cos\\left(t \\log\\left(13\\right)\\right) \\log\\left(13\\right) + \\frac{1}{11} \\, \\sqrt{11} \\cos\\left(t \\log\\left(11\\right)\\right) \\log\\left(11\\right) + \\frac{1}{7} \\, \\sqrt{7} \\cos\\left(t \\log\\left(7\\right)\\right) \\log\\left(7\\right) - \\frac{1}{5} \\, \\sqrt{5} \\cos\\left(t \\log\\left(5\\right)\\right) \\log\\left(5\\right) + \\frac{1}{3} \\, \\sqrt{3} \\cos\\left(t \\log\\left(3\\right)\\right) \\log\\left(3\\right) + \\frac{1}{3} \\, \\cos\\left(t \\log\\left(9\\right)\\right) \\log\\left(3\\right)$</div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"01f51a98-ce0c-4d85-bbdd-93f33dcbef39","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_Ooz7Jj.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠7677eb4e-94d3-461a-b57d-42d435221637︠
%time
f = gauss_symbolic_phihat(200); show(f)
f.plot(0, 20, plot_points=100)
︡afe80b29-dc2b-4076-ab92-a78b4fede542︡︡{"html":"<div align='center'>$\\displaystyle \\frac{1}{199} \\, \\sqrt{199} \\cos\\left(t \\log\\left(199\\right)\\right) \\log\\left(199\\right) - \\frac{1}{197} \\, \\sqrt{197} \\cos\\left(t \\log\\left(197\\right)\\right) \\log\\left(197\\right) - \\frac{1}{193} \\, \\sqrt{193} \\cos\\left(t \\log\\left(193\\right)\\right) \\log\\left(193\\right) + \\frac{1}{191} \\, \\sqrt{191} \\cos\\left(t \\log\\left(191\\right)\\right) \\log\\left(191\\right) - \\frac{1}{181} \\, \\sqrt{181} \\cos\\left(t \\log\\left(181\\right)\\right) \\log\\left(181\\right) + \\frac{1}{179} \\, \\sqrt{179} \\cos\\left(t \\log\\left(179\\right)\\right) \\log\\left(179\\right) - \\frac{1}{173} \\, \\sqrt{173} \\cos\\left(t \\log\\left(173\\right)\\right) \\log\\left(173\\right) + \\frac{1}{167} \\, \\sqrt{167} \\cos\\left(t \\log\\left(167\\right)\\right) \\log\\left(167\\right) + \\frac{1}{163} \\, \\sqrt{163} \\cos\\left(t \\log\\left(163\\right)\\right) \\log\\left(163\\right) - \\frac{1}{157} \\, \\sqrt{157} \\cos\\left(t \\log\\left(157\\right)\\right) \\log\\left(157\\right) + \\frac{1}{151} \\, \\sqrt{151} \\cos\\left(t \\log\\left(151\\right)\\right) \\log\\left(151\\right) - \\frac{1}{149} \\, \\sqrt{149} \\cos\\left(t \\log\\left(149\\right)\\right) \\log\\left(149\\right) + \\frac{1}{139} \\, \\sqrt{139} \\cos\\left(t \\log\\left(139\\right)\\right) \\log\\left(139\\right) - \\frac{1}{137} \\, \\sqrt{137} \\cos\\left(t \\log\\left(137\\right)\\right) \\log\\left(137\\right) + \\frac{1}{131} \\, \\sqrt{131} \\cos\\left(t \\log\\left(131\\right)\\right) \\log\\left(131\\right) + \\frac{1}{127} \\, \\sqrt{127} \\cos\\left(t \\log\\left(127\\right)\\right) \\log\\left(127\\right) - \\frac{1}{113} \\, \\sqrt{113} \\cos\\left(t \\log\\left(113\\right)\\right) \\log\\left(113\\right) - \\frac{1}{109} \\, \\sqrt{109} \\cos\\left(t \\log\\left(109\\right)\\right) \\log\\left(109\\right) + \\frac{1}{107} \\, \\sqrt{107} \\cos\\left(t \\log\\left(107\\right)\\right) \\log\\left(107\\right) + \\frac{1}{103} \\, \\sqrt{103} \\cos\\left(t \\log\\left(103\\right)\\right) \\log\\left(103\\right) - \\frac{1}{101} \\, \\sqrt{101} \\cos\\left(t \\log\\left(101\\right)\\right) \\log\\left(101\\right) - \\frac{1}{97} \\, \\sqrt{97} \\cos\\left(t \\log\\left(97\\right)\\right) \\log\\left(97\\right) - \\frac{1}{89} \\, \\sqrt{89} \\cos\\left(t \\log\\left(89\\right)\\right) \\log\\left(89\\right) + \\frac{1}{83} \\, \\sqrt{83} \\cos\\left(t \\log\\left(83\\right)\\right) \\log\\left(83\\right) + \\frac{1}{79} \\, \\sqrt{79} \\cos\\left(t \\log\\left(79\\right)\\right) \\log\\left(79\\right) - \\frac{1}{73} \\, \\sqrt{73} \\cos\\left(t \\log\\left(73\\right)\\right) \\log\\left(73\\right) + \\frac{1}{71} \\, \\sqrt{71} \\cos\\left(t \\log\\left(71\\right)\\right) \\log\\left(71\\right) + \\frac{1}{67} \\, \\sqrt{67} \\cos\\left(t \\log\\left(67\\right)\\right) \\log\\left(67\\right) - \\frac{1}{61} \\, \\sqrt{61} \\cos\\left(t \\log\\left(61\\right)\\right) \\log\\left(61\\right) + \\frac{1}{59} \\, \\sqrt{59} \\cos\\left(t \\log\\left(59\\right)\\right) \\log\\left(59\\right) - \\frac{1}{53} \\, \\sqrt{53} \\cos\\left(t \\log\\left(53\\right)\\right) \\log\\left(53\\right) + \\frac{1}{47} \\, \\sqrt{47} \\cos\\left(t \\log\\left(47\\right)\\right) \\log\\left(47\\right) + \\frac{1}{43} \\, \\sqrt{43} \\cos\\left(t \\log\\left(43\\right)\\right) \\log\\left(43\\right) - \\frac{1}{41} \\, \\sqrt{41} \\cos\\left(t \\log\\left(41\\right)\\right) \\log\\left(41\\right) - \\frac{1}{37} \\, \\sqrt{37} \\cos\\left(t \\log\\left(37\\right)\\right) \\log\\left(37\\right) + \\frac{1}{31} \\, \\sqrt{31} \\cos\\left(t \\log\\left(31\\right)\\right) \\log\\left(31\\right) - \\frac{1}{29} \\, \\sqrt{29} \\cos\\left(t \\log\\left(29\\right)\\right) \\log\\left(29\\right) + \\frac{1}{23} \\, \\sqrt{23} \\cos\\left(t \\log\\left(23\\right)\\right) \\log\\left(23\\right) + \\frac{1}{19} \\, \\sqrt{19} \\cos\\left(t \\log\\left(19\\right)\\right) \\log\\left(19\\right) - \\frac{1}{17} \\, \\sqrt{17} \\cos\\left(t \\log\\left(17\\right)\\right) \\log\\left(17\\right) - \\frac{1}{13} \\, \\sqrt{13} \\cos\\left(t \\log\\left(13\\right)\\right) \\log\\left(13\\right) + \\frac{1}{11} \\, \\sqrt{11} \\cos\\left(t \\log\\left(11\\right)\\right) \\log\\left(11\\right) + \\frac{1}{7} \\, \\sqrt{7} \\cos\\left(t \\log\\left(7\\right)\\right) \\log\\left(7\\right) - \\frac{1}{25} \\, \\sqrt{5} \\cos\\left(t \\log\\left(125\\right)\\right) \\log\\left(5\\right) - \\frac{1}{5} \\, \\sqrt{5} \\cos\\left(t \\log\\left(5\\right)\\right) \\log\\left(5\\right) + \\frac{1}{9} \\, \\sqrt{3} \\cos\\left(t \\log\\left(27\\right)\\right) \\log\\left(3\\right) + \\frac{1}{3} \\, \\sqrt{3} \\cos\\left(t \\log\\left(3\\right)\\right) \\log\\left(3\\right) - \\frac{1}{13} \\, \\cos\\left(t \\log\\left(169\\right)\\right) \\log\\left(13\\right) + \\frac{1}{11} \\, \\cos\\left(t \\log\\left(121\\right)\\right) \\log\\left(11\\right) + \\frac{1}{7} \\, \\cos\\left(t \\log\\left(49\\right)\\right) \\log\\left(7\\right) - \\frac{1}{5} \\, \\cos\\left(t \\log\\left(25\\right)\\right) \\log\\left(5\\right) + \\frac{1}{9} \\, \\cos\\left(t \\log\\left(81\\right)\\right) \\log\\left(3\\right) + \\frac{1}{3} \\, \\cos\\left(t \\log\\left(9\\right)\\right) \\log\\left(3\\right)$</div>","done":false}︡{"once":false,"done":false,"file":{"show":true,"uuid":"d8219f77-bf9b-47d0-90f4-968031359051","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_qBEndC.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"stdout":"CPU time: 33.98 s, Wall time: 34.76 s","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠6e02dbd7-acb2-4a0b-b856-861eb360e041︠
zeros(100)
︡0d47eab5-b924-4826-900f-54aaae25e24c︡︡{"stdout":"[6.0209489046976, 10.243770304167, 12.988098012312, 16.342607104587, 18.291993196124, 21.450611343983, 23.27837652046, 25.728756425089, 28.359634343025, 29.656384014593, 32.592186527117, 34.199957509213, 36.142880458303, 38.511923141719, 40.322674066691, 41.807084620005, 44.617891058662, 45.599584396792, 47.741562280939, 49.723129323783, 51.686093452871, 52.768820767805, 55.267543584699, 56.934374055202, 58.116707110674, 60.421713949008, 62.008632285768, 63.714641118785, 64.976170573096, 67.636920863546, 68.365884503834, 70.185879908802, 72.155484974382, 73.767635521486, 75.143121647433, 76.69630320343, 78.809998314321, 80.210131238367, 81.213951626883, 83.666656014471, 84.731740363782, 86.57766016839, 87.629718119588, 89.801131616696, 91.349703814698, 92.237499910454, 94.16661958596, 96.136011161781, 96.961741579417, 98.755300415755]","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠87ddbda6-53bd-46a5-8d9d-0c438a1bfc0b︠
g = f.derivative()
︡cb3ebb35-9f2e-4e78-9d9e-e920cfeafc1d︡︡{"done":true}
︠38a6bd0e-73f4-4ac1-b1e3-5f26e26e4c03︠
f.find_local_maximum(5.5,6.5)
︡3e46cb43-fa54-4f0c-a8eb-eba30159554c︡︡{"stdout":"(4.625184318694296, 6.0932418136308746)","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠b873b104-ae59-4707-98b3-23d3c4020516︠
%time f = gauss_symbolic_phihat(20000)
f.find_local_maximum(5.5,6.5)
︡fec9baae-aa6d-43b3-8223-ee7109a7ff3d︡︡{"stdout":"CPU time: 1.40 s, Wall time: 1.42 s","done":false}︡{"stdout":"\n","done":false}︡{"stdout":"(9.609716603100983, 6.0190156444824714)","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠2ccfc010-a193-463d-aa1b-cf8dc2ab250f︠
%time f = gauss_symbolic_phihat(100000)
f.find_local_maximum(5.5,6.5)
︡2d325e3f-ff5b-4f50-aadb-e8fad5cf0e9c︡︡{"stdout":"CPU time: 9.16 s, Wall time: 9.49 s","done":false}︡{"stdout":"\n","done":false}︡{"stdout":"(10.306059947208393, 6.0248752427482559)","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠64722ae0-f2c7-442f-b5cf-4b38a4625a84︠
g = f._fast_float_()
︡0008d528-00e1-4e6a-8140-406213a62fb8︡︡{"done":false,"stderr":"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/sage/symbolic/expression_conversions.py:1387: DeprecationWarning: Substitution using function-call syntax and unnamed arguments is deprecated and will be removed from a future release of Sage; you can use named arguments instead, like EXPR(x=..., y=...)\nSee http://trac.sagemath.org/5930 for details.\n  return FastFloatConverter(ex, *vars)()\n"}︡{"done":true}
︠514e86d5-6c95-4c35-a631-c53a91e5bd64︠
%time plot(g, 5, 100)
︡f5ee81ce-e3ae-45ed-8646-51c0c7551b9f︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"d2428f53-a01d-45fb-ad60-fb61ce6a766a","filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/15174/tmp_vmQPCa.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"stdout":"CPU time: 8.78 s, Wall time: 8.88 s","done":false}︡{"stdout":"\n","done":false}︡{"done":true}
︠af37eef6-71dd-444d-9271-6478963915a8︠
p = 1e9
N(log(p)/sqrt(p))
︡673bf1f4-fb36-4df4-90a5-5f36e5bf741b︡︡{"stdout":"0.000655327206019062\n","done":false}︡{"done":true}
︠8ea453af-177b-4c3b-9184-0189d08d727d︠

@cached_function
def zeros(y, ring):
    s = os.popen('lcalc --zeros-interval -x 1 -y %s --stepsize .01 --twist-quadratic -s %s -f %s'%(y, ring.discriminant(),
                                                                                                  ring.discriminant())).readlines()
    return [float(z.split()[1]) for z in s]

#omit 2 and - signs for p = 3 (mod 4)
#do Fourier trans on sum in phi
def arb_symbolic_phihat(bound,delta):
    t = var('t')
    f = SR(0)#what is this - all expressions learned in calculus
    for pn in prime_powers(bound+1):
        if pn == 1: continue
        if pn % 2 != 0:
            p, e = factor(pn)[0]
            #print "Kronecker for prime %s of delta %s is %s" % (p, delta, kronecker(delta, p))
            f += -kronecker(delta,p) * log(p)/sqrt(pn) * cos(t*log(pn))
    return f

def arb_plot_symbolic_phihat(bound, xmin, xmax, delta = -1, plot_points=1000, show_zeros=True):
    f = arb_symbolic_phihat(bound, delta)
    K.<i> = QQ[sqrt(delta)]
    P = plot(f, (t,xmin, xmax), plot_points=plot_points)
    if not show_zeros:
        return P
    ym = P.ymax()
    Z = []
    for y in zeros(xmax, K):
        Z.append(y)
    zeros_arrows = sum([arrow((x,ym),(x,0),rgbcolor='red',width=0.5,arrowsize=2)
                 for i, x in enumerate(Z)])
    return P + zeros_arrows

p = arb_plot_symbolic_phihat(100, 2, 30, -5)
p.show()
︡241a63d2-bdab-4e05-bb58-c8590aa056fd︡︡{"file":{"filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/9193/tmp_XBypab.svg","show":true,"text":null,"uuid":"5f24dc7b-90b2-4dcb-ba90-35de7ca5e640"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠f017402a-e26d-46af-8604-f3ae6dffbd42︠
g = gauss_plot_symbolic_phihat(100, 2, 30)
g.show()
︡456a1836-7701-4f04-8cab-651bfaae7cb7︡︡{"file":{"filename":"/projects/e36562c2-4012-4f73-99b2-9c779691ff75/.sage/temp/compute5-us/9193/tmp_tANCAS.svg","show":true,"text":null,"uuid":"ee7826c1-b5ed-475b-a9fd-2b793b7215d5"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}

︠2d02a7c2-0771-4f7a-9844-dcb1c93c02f1︠
K.<i> = QQ[sqrt(-1)]
K.discriminant??

︡4eb14f42-71b9-403a-8ee0-39bc96d0d093︡︡{"done":true}










